7710: add crunchrunner to gostuff
[arvados-dev.git] / jenkins / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 read -rd "\000" helpmessage <<EOF
6 $(basename $0): Install and test Arvados components.
7
8 Exit non-zero if any tests fail.
9
10 Syntax:
11         $(basename $0) WORKSPACE=/path/to/arvados [options]
12
13 Options:
14
15 --skip FOO     Do not test the FOO component.
16 --only FOO     Do not test anything except the FOO component.
17 --temp DIR     Install components and dependencies under DIR instead of
18                making a new temporary directory. Implies --leave-temp.
19 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
20                Instead, show the path to give as --temp to reuse them in
21                subsequent invocations.
22 --skip-install Do not run any install steps. Just run tests.
23                You should provide GOPATH, GEMHOME, and VENVDIR options
24                from a previous invocation if you use this option.
25 --only-install Run specific install step
26 WORKSPACE=path Arvados source tree to test.
27 CONFIGSRC=path Dir with api server config files to copy into source tree.
28                (If none given, leave config files alone in source tree.)
29 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
30                Restrict apiserver tests to the given file
31 sdk/python_test="--test-suite test.test_keep_locator"
32                Restrict Python SDK tests to the given class
33 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
34                Restrict Workbench tests to the given file
35 services/arv-git-httpd_test="-check.vv"
36                Show all log messages, even when tests pass (also works
37                with services/keepstore_test etc.)
38 ARVADOS_DEBUG=1
39                Print more debug messages
40 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
41                *_test, and other examples shown above.
42
43 Assuming --skip-install is not given, all components are installed
44 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
45 test suites depend on other components being installed, and installing
46 everything tends to be quicker than debugging dependencies.
47
48 As a special concession to the current CI server config, CONFIGSRC
49 defaults to $HOME/arvados-api-server if that directory exists.
50
51 More information and background:
52
53 https://arvados.org/projects/arvados/wiki/Running_tests
54
55 Available tests:
56
57 apps/workbench
58 apps/workbench_benchmark
59 apps/workbench_profile
60 doc
61 services/api
62 services/arv-git-httpd
63 services/crunchstat
64 services/dockercleaner
65 services/fuse
66 services/keep-web
67 services/keepproxy
68 services/keepstore
69 services/login-sync
70 services/nodemanager
71 sdk/cli
72 sdk/pam
73 sdk/python
74 sdk/ruby
75 sdk/go/arvadosclient
76 sdk/go/keepclient
77 sdk/go/manifest
78 sdk/go/blockdigest
79 sdk/go/streamer
80 sdk/go/crunchrunner
81 tools/keep-rsync
82
83 EOF
84
85 # First make sure to remove any ARVADOS_ variables from the calling
86 # environment that could interfere with the tests.
87 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
88
89 # Reset other variables that could affect our [tests'] behavior by
90 # accident.
91 GITDIR=
92 GOPATH=
93 VENVDIR=
94 VENV3DIR=
95 PYTHONPATH=
96 GEMHOME=
97 PERLINSTALLBASE=
98
99 COLUMNS=80
100
101 skip_install=
102 temp=
103 temp_preserve=
104
105 clear_temp() {
106     if [[ -z "$temp" ]]; then
107         # we didn't even get as far as making a temp dir
108         :
109     elif [[ -z "$temp_preserve" ]]; then
110         rm -rf "$temp"
111     else
112         echo "Leaving behind temp dirs in $temp"
113     fi
114 }
115
116 fatal() {
117     clear_temp
118     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
119     exit 1
120 }
121
122 report_outcomes() {
123     for x in "${successes[@]}"
124     do
125         echo "Pass: $x"
126     done
127
128     if [[ ${#failures[@]} == 0 ]]
129     then
130         echo "All test suites passed."
131     else
132         echo "Failures (${#failures[@]}):"
133         for x in "${failures[@]}"
134         do
135             echo "Fail: $x"
136         done
137     fi
138 }
139
140 exit_cleanly() {
141     trap - INT
142     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
143     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
144     stop_services
145     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
146     report_outcomes
147     clear_temp
148     exit ${#failures}
149 }
150
151 sanity_checks() {
152     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
153         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
154     echo Checking dependencies:
155     echo -n 'virtualenv: '
156     virtualenv --version \
157         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
158     echo -n 'go: '
159     go version \
160         || fatal "No go binary. See http://golang.org/doc/install"
161     echo -n 'gcc: '
162     gcc --version | egrep ^gcc \
163         || fatal "No gcc. Try: apt-get install build-essential"
164     echo -n 'fuse.h: '
165     find /usr/include -wholename '*fuse/fuse.h' \
166         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
167     echo -n 'pyconfig.h: '
168     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
169         || fatal "No pyconfig.h. Try: apt-get install python-dev"
170     echo -n 'nginx: '
171     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
172         || fatal "No nginx. Try: apt-get install nginx"
173     echo -n 'perl: '
174     perl -v | grep version \
175         || fatal "No perl. Try: apt-get install perl"
176     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
177         echo -n "perl $mod: "
178         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
179             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
180     done
181     echo -n 'gitolite: '
182     which gitolite \
183         || fatal "No gitolite. Try: apt-get install gitolite3"
184 }
185
186 rotate_logfile() {
187   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
188   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
189   if [[ -f "$1/$2" ]]; then
190     THEDATE=`date +%Y%m%d%H%M%S`
191     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
192     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
193   fi
194 }
195
196 declare -a failures
197 declare -A skip
198 declare -A testargs
199 skip[apps/workbench_profile]=1
200
201 while [[ -n "$1" ]]
202 do
203     arg="$1"; shift
204     case "$arg" in
205         --help)
206             echo >&2 "$helpmessage"
207             echo >&2
208             exit 1
209             ;;
210         --skip)
211             skipwhat="$1"; shift
212             skip[$skipwhat]=1
213             ;;
214         --only)
215             only="$1"; skip[$1]=""; shift
216             ;;
217         --skip-install)
218             skip_install=1
219             ;;
220         --only-install)
221             skip_install=1
222             only_install="$1"; shift
223             ;;
224         --temp)
225             temp="$1"; shift
226             temp_preserve=1
227             ;;
228         --leave-temp)
229             temp_preserve=1
230             ;;
231         --retry)
232             retry=1
233             ;;
234         *_test=*)
235             suite="${arg%%_test=*}"
236             args="${arg#*=}"
237             testargs["$suite"]="$args"
238             ;;
239         *=*)
240             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
241             ;;
242         *)
243             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
244             exit 1
245             ;;
246     esac
247 done
248
249 start_api() {
250     echo 'Starting API server...'
251     cd "$WORKSPACE" \
252         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
253         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
254         && export ARVADOS_TEST_API_INSTALLED="$$" \
255         && (env | egrep ^ARVADOS)
256 }
257
258 start_nginx_proxy_services() {
259     echo 'Starting keepproxy, keep-web, arv-git-httpd, and nginx ssl proxy...'
260     cd "$WORKSPACE" \
261         && python sdk/python/tests/run_test_server.py start_keep_proxy \
262         && python sdk/python/tests/run_test_server.py start_keep-web \
263         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
264         && python sdk/python/tests/run_test_server.py start_nginx \
265         && export ARVADOS_TEST_PROXY_SERVICES=1
266 }
267
268 stop_services() {
269     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
270         unset ARVADOS_TEST_PROXY_SERVICES
271         cd "$WORKSPACE" \
272             && python sdk/python/tests/run_test_server.py stop_nginx \
273             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
274             && python sdk/python/tests/run_test_server.py stop_keep-web \
275             && python sdk/python/tests/run_test_server.py stop_keep_proxy
276     fi
277     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
278         unset ARVADOS_TEST_API_HOST
279         cd "$WORKSPACE" \
280             && python sdk/python/tests/run_test_server.py stop
281     fi
282 }
283
284 interrupt() {
285     failures+=("($(basename $0) interrupted)")
286     exit_cleanly
287 }
288 trap interrupt INT
289
290 sanity_checks
291
292 echo "WORKSPACE=$WORKSPACE"
293
294 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
295     # Jenkins expects us to use this by default.
296     CONFIGSRC="$HOME/arvados-api-server"
297 fi
298
299 # Clean up .pyc files that may exist in the workspace
300 cd "$WORKSPACE"
301 find -name '*.pyc' -delete
302
303 if [[ -z "$temp" ]]; then
304     temp="$(mktemp -d)"
305 fi
306
307 # Set up temporary install dirs (unless existing dirs were supplied)
308 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
309 do
310     if [[ -z "${!tmpdir}" ]]; then
311         eval "$tmpdir"="$temp/$tmpdir"
312     fi
313     if ! [[ -d "${!tmpdir}" ]]; then
314         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
315     fi
316 done
317
318 setup_ruby_environment() {
319     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
320       source "$HOME/.rvm/scripts/rvm"
321       using_rvm=true
322     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
323       source "/usr/local/rvm/scripts/rvm"
324       using_rvm=true
325     else
326       using_rvm=false
327     fi
328
329     if [[ "$using_rvm" == true ]]; then
330         # If rvm is in use, we can't just put separate "dependencies"
331         # and "gems-under-test" paths to GEM_PATH: passenger resets
332         # the environment to the "current gemset", which would lose
333         # our GEM_PATH and prevent our test suites from running ruby
334         # programs (for example, the Workbench test suite could not
335         # boot an API server or run arv). Instead, we have to make an
336         # rvm gemset and use it for everything.
337
338         [[ `type rvm | head -n1` == "rvm is a function" ]] \
339             || fatal 'rvm check'
340
341         # Put rvm's favorite path back in first place (overriding
342         # virtualenv, which just put itself there). Ignore rvm's
343         # complaint about not being in first place already.
344         rvm use @default 2>/dev/null
345
346         # Create (if needed) and switch to an @arvados-tests
347         # gemset. (Leave the choice of ruby to the caller.)
348         rvm use @arvados-tests --create \
349             || fatal 'rvm gemset setup'
350
351         rvm env
352     else
353         # When our "bundle install"s need to install new gems to
354         # satisfy dependencies, we want them to go where "gem install
355         # --user-install" would put them. (However, if the caller has
356         # already set GEM_HOME, we assume that's where dependencies
357         # should be installed, and we should leave it alone.)
358
359         if [ -z "$GEM_HOME" ]; then
360             user_gempath="$(gem env gempath)"
361             export GEM_HOME="${user_gempath%%:*}"
362         fi
363         PATH="$(gem env gemdir)/bin:$PATH"
364
365         # When we build and install our own gems, we install them in our
366         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
367         # PATH so integration tests prefer them over other versions that
368         # happen to be installed in $user_gempath, system dirs, etc.
369
370         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
371         PATH="$tmpdir_gem_home/bin:$PATH"
372         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
373
374         echo "Will install dependencies to $(gem env gemdir)"
375         echo "Will install arvados gems to $tmpdir_gem_home"
376         echo "Gem search path is GEM_PATH=$GEM_PATH"
377     fi
378 }
379
380 with_test_gemset() {
381     if [[ "$using_rvm" == true ]]; then
382         "$@"
383     else
384         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
385     fi
386 }
387
388 gem_uninstall_if_exists() {
389     if gem list "$1\$" | egrep '^\w'; then
390         gem uninstall --force --all --executables "$1"
391     fi
392 }
393
394 setup_virtualenv() {
395     local venvdest=$1; shift
396     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
397         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
398     fi
399     "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7'
400     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
401     "$venvdest/bin/pip" install 'mock>=1.0' 'pbr<1.7.0'
402 }
403
404 export PERLINSTALLBASE
405 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
406
407 export GOPATH
408 mkdir -p "$GOPATH/src/git.curoverse.com"
409 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
410     || fatal "symlink failed"
411
412 setup_virtualenv "$VENVDIR" --python python2.7
413 . "$VENVDIR/bin/activate"
414
415 # Needed for run_test_server.py which is used by certain (non-Python) tests.
416 pip freeze 2>/dev/null | egrep ^PyYAML= \
417     || pip install PyYAML >/dev/null \
418     || fatal "pip install PyYAML failed"
419
420 # Preinstall forked version of libcloud, because nodemanager "pip install"
421 # won't pick it up by default.
422 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
423     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
424     || fatal "pip install apache-libcloud failed"
425
426 # Deactivate Python 2 virtualenv
427 deactivate
428
429 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
430 # Otherwise, skip dependent tests.
431 PYTHON3=$(which python3)
432 if [ "0" = "$?" ]; then
433     setup_virtualenv "$VENV3DIR" --python python3
434 else
435     PYTHON3=
436     skip[services/dockercleaner]=1
437     cat >&2 <<EOF
438
439 Warning: python3 could not be found
440 services/dockercleaner install and tests will be skipped
441
442 EOF
443 fi
444
445 # Reactivate Python 2 virtualenv
446 . "$VENVDIR/bin/activate"
447
448 # Note: this must be the last time we change PATH, otherwise rvm will
449 # whine a lot.
450 setup_ruby_environment
451
452 echo "PATH is $PATH"
453
454 if ! which bundler >/dev/null
455 then
456     gem install --user-install bundler || fatal 'Could not install bundler'
457 fi
458
459 checkexit() {
460     if [[ "$1" != "0" ]]; then
461         title "!!!!!! $2 FAILED !!!!!!"
462         failures+=("$2 (`timer`)")
463     else
464         successes+=("$2 (`timer`)")
465     fi
466 }
467
468 timer_reset() {
469     t0=$SECONDS
470 }
471
472 timer() {
473     echo -n "$(($SECONDS - $t0))s"
474 }
475
476 do_test() {
477     while ! do_test_once ${@} && [[ "$retry" == 1 ]]
478     do
479         read -p 'Try again? [Y/n] ' x
480         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
481         then
482             break
483         fi
484     done
485 }
486
487 do_test_once() {
488     unset result
489     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
490     then
491         title "Running $1 tests"
492         timer_reset
493         if [[ "$2" == "go" ]]
494         then
495             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
496             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
497             # We do "go get -t" here to catch compilation errors
498             # before trying "go test". Otherwise, coverage-reporting
499             # mode makes Go show the wrong line numbers when reporting
500             # compilation errors.
501             if [[ -n "${testargs[$1]}" ]]
502             then
503                 # "go test -check.vv giturl" doesn't work, but this
504                 # does:
505                 cd "$WORKSPACE/$1" && \
506                     go get -t "git.curoverse.com/arvados.git/$1" && \
507                     go test ${coverflags[@]} ${testargs[$1]}
508             else
509                 # The above form gets verbose even when testargs is
510                 # empty, so use this form in such cases:
511                 go get -t "git.curoverse.com/arvados.git/$1" && \
512                     go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
513             fi
514             result="$?"
515             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
516             rm "$WORKSPACE/tmp/.$covername.tmp"
517         elif [[ "$2" == "pip" ]]
518         then
519             # $3 can name a path directory for us to use, including trailing
520             # slash; e.g., the bin/ subdirectory of a virtualenv.
521             cd "$WORKSPACE/$1" \
522                 && "${3}python" setup.py test ${testargs[$1]}
523         elif [[ "$2" != "" ]]
524         then
525             "test_$2"
526         else
527             "test_$1"
528         fi
529         result=${result:-$?}
530         checkexit $result "$1 tests"
531         title "End of $1 tests (`timer`)"
532         return $result
533     else
534         title "Skipping $1 tests"
535     fi
536 }
537
538 do_install() {
539     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
540     then
541         title "Running $1 install"
542         timer_reset
543         if [[ "$2" == "go" ]]
544         then
545             go get -t "git.curoverse.com/arvados.git/$1"
546         elif [[ "$2" == "pip" ]]
547         then
548             # $3 can name a path directory for us to use, including trailing
549             # slash; e.g., the bin/ subdirectory of a virtualenv.
550
551             # Need to change to a different directory after creating
552             # the source dist package to avoid a pip bug.
553             # see https://arvados.org/issues/5766 for details.
554
555             # Also need to install twice, because if it believes the package is
556             # already installed, pip it won't install it.  So the first "pip
557             # install" ensures that the dependencies are met, the second "pip
558             # install" ensures that we've actually installed the local package
559             # we just built.
560             cd "$WORKSPACE/$1" \
561                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
562                 && cd "$WORKSPACE" \
563                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
564                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
565         elif [[ "$2" != "" ]]
566         then
567             "install_$2"
568         else
569             "install_$1"
570         fi
571         checkexit $? "$1 install"
572         title "End of $1 install (`timer`)"
573     else
574         title "Skipping $1 install"
575     fi
576 }
577
578 title () {
579     txt="********** $1 **********"
580     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
581 }
582
583 bundle_install_trylocal() {
584     (
585         set -e
586         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
587         if ! bundle install --local --no-deployment; then
588             echo "(Running bundle install again, without --local.)"
589             bundle install --no-deployment
590         fi
591         bundle package --all
592     )
593 }
594
595 install_doc() {
596     cd "$WORKSPACE/doc" \
597         && bundle_install_trylocal \
598         && rm -rf .site
599 }
600 do_install doc
601
602 install_gem() {
603     gemname=$1
604     srcpath=$2
605     with_test_gemset gem_uninstall_if_exists "$gemname" \
606         && cd "$WORKSPACE/$srcpath" \
607         && bundle_install_trylocal \
608         && gem build "$gemname.gemspec" \
609         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
610 }
611
612 install_ruby_sdk() {
613     install_gem arvados sdk/ruby
614 }
615 do_install sdk/ruby ruby_sdk
616
617 install_perl_sdk() {
618     cd "$WORKSPACE/sdk/perl" \
619         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
620         && make install INSTALLDIRS=perl
621 }
622 do_install sdk/perl perl_sdk
623
624 install_cli() {
625     install_gem arvados-cli sdk/cli
626 }
627 do_install sdk/cli cli
628
629 install_login-sync() {
630     install_gem arvados-login-sync services/login-sync
631 }
632 do_install services/login-sync login-sync
633
634 # Install the Python SDK early. Various other test suites (like
635 # keepproxy) bring up run_test_server.py, which imports the arvados
636 # module. We can't actually *test* the Python SDK yet though, because
637 # its own test suite brings up some of those other programs (like
638 # keepproxy).
639 declare -a pythonstuff
640 pythonstuff=(
641     sdk/pam
642     sdk/python
643     services/fuse
644     services/nodemanager
645     )
646 for p in "${pythonstuff[@]}"
647 do
648     do_install "$p" pip
649 done
650 if [ -n "$PYTHON3" ]; then
651     do_install services/dockercleaner pip "$VENV3DIR/bin/"
652 fi
653
654 install_apiserver() {
655     cd "$WORKSPACE/services/api" \
656         && RAILS_ENV=test bundle_install_trylocal
657
658     rm -f config/environments/test.rb
659     cp config/environments/test.rb.example config/environments/test.rb
660
661     if [ -n "$CONFIGSRC" ]
662     then
663         for f in database.yml application.yml
664         do
665             cp "$CONFIGSRC/$f" config/ || fatal "$f"
666         done
667     fi
668
669     # Fill in a random secret_token and blob_signing_key for testing
670     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
671     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
672
673     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
674     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
675
676     # Set up empty git repo (for git tests)
677     GITDIR=$(mktemp -d)
678     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
679
680     rm -rf $GITDIR
681     mkdir -p $GITDIR/test
682     cd $GITDIR/test \
683         && git init \
684         && git config user.email "jenkins@ci.curoverse.com" \
685         && git config user.name "Jenkins, CI" \
686         && touch tmp \
687         && git add tmp \
688         && git commit -m 'initial commit'
689
690     # Clear out any lingering postgresql connections to the test
691     # database, so that we can drop it. This assumes the current user
692     # is a postgresql superuser.
693     cd "$WORKSPACE/services/api" \
694         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
695         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
696
697     cd "$WORKSPACE/services/api" \
698         && RAILS_ENV=test bundle exec rake db:drop \
699         && RAILS_ENV=test bundle exec rake db:setup \
700         && RAILS_ENV=test bundle exec rake db:fixtures:load
701 }
702 do_install services/api apiserver
703
704 declare -a gostuff
705 gostuff=(
706     sdk/go/arvadosclient
707     sdk/go/blockdigest
708     sdk/go/manifest
709     sdk/go/streamer
710     sdk/go/crunchrunner
711     services/arv-git-httpd
712     services/crunchstat
713     services/keep-web
714     services/keepstore
715     sdk/go/keepclient
716     services/keepproxy
717     services/datamanager/summary
718     services/datamanager/collection
719     services/datamanager/keep
720     services/datamanager
721     tools/keep-rsync
722     )
723 for g in "${gostuff[@]}"
724 do
725     do_install "$g" go
726 done
727
728 install_workbench() {
729     cd "$WORKSPACE/apps/workbench" \
730         && mkdir -p tmp/cache \
731         && RAILS_ENV=test bundle_install_trylocal
732 }
733 do_install apps/workbench workbench
734
735 test_doclinkchecker() {
736     (
737         set -e
738         cd "$WORKSPACE/doc"
739         ARVADOS_API_HOST=qr1hi.arvadosapi.com
740         # Make sure python-epydoc is installed or the next line won't
741         # do much good!
742         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
743     )
744 }
745 do_test doc doclinkchecker
746
747 stop_services
748
749 test_apiserver() {
750     cd "$WORKSPACE/services/api" \
751         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
752 }
753 do_test services/api apiserver
754
755 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
756 # because we don't need to start up the api server for subsequent tests.
757 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
758   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
759   exit_cleanly
760 fi
761
762 start_api
763
764 test_ruby_sdk() {
765     cd "$WORKSPACE/sdk/ruby" \
766         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
767 }
768 do_test sdk/ruby ruby_sdk
769
770 test_cli() {
771     cd "$WORKSPACE/sdk/cli" \
772         && mkdir -p /tmp/keep \
773         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
774 }
775 do_test sdk/cli cli
776
777 test_login-sync() {
778     cd "$WORKSPACE/services/login-sync" \
779         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
780 }
781 do_test services/login-sync login-sync
782
783 for p in "${pythonstuff[@]}"
784 do
785     do_test "$p" pip
786 done
787 do_test services/dockercleaner pip "$VENV3DIR/bin/"
788
789 for g in "${gostuff[@]}"
790 do
791     do_test "$g" go
792 done
793
794 test_workbench() {
795     start_nginx_proxy_services \
796         && cd "$WORKSPACE/apps/workbench" \
797         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
798 }
799 do_test apps/workbench workbench
800
801 test_workbench_benchmark() {
802     start_nginx_proxy_services \
803         && cd "$WORKSPACE/apps/workbench" \
804         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
805 }
806 do_test apps/workbench_benchmark workbench_benchmark
807
808 test_workbench_profile() {
809     start_nginx_proxy_services \
810         && cd "$WORKSPACE/apps/workbench" \
811         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
812 }
813 do_test apps/workbench_profile workbench_profile
814
815 exit_cleanly